package org.dromara.elevator.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.elevator.domain.EBuildingInfo;
import org.springframework.stereotype.Service;
import org.dromara.elevator.domain.bo.EElevatorAccessoryBo;
import org.dromara.elevator.domain.vo.EElevatorAccessoryVo;
import org.dromara.elevator.domain.EElevatorAccessory;
import org.dromara.elevator.mapper.EElevatorAccessoryMapper;
import org.dromara.elevator.service.IEElevatorAccessoryService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 电梯配件信息;Service业务层处理
 *
 * @author zy
 * @date 2024-08-13
 */
@RequiredArgsConstructor
@Service
public class EElevatorAccessoryServiceImpl implements IEElevatorAccessoryService {

    private final EElevatorAccessoryMapper baseMapper;

    /**
     * 查询电梯配件信息;
     *
     * @param id 主键
     * @return 电梯配件信息;
     */
    @Override
    public EElevatorAccessoryVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询电梯配件信息;列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 电梯配件信息;分页列表
     */
    @Override
    public TableDataInfo<EElevatorAccessoryVo> queryPageList(EElevatorAccessoryBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<EElevatorAccessory> lqw = buildQueryWrapper(bo);
        Page<EElevatorAccessoryVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的电梯配件信息;列表
     *
     * @param bo 查询条件
     * @return 电梯配件信息;列表
     */
    @Override
    public List<EElevatorAccessoryVo> queryList(EElevatorAccessoryBo bo) {
        LambdaQueryWrapper<EElevatorAccessory> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<EElevatorAccessory> buildQueryWrapper(EElevatorAccessoryBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<EElevatorAccessory> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getCode()), EElevatorAccessory::getCode, bo.getCode());
        lqw.like(StringUtils.isNotBlank(bo.getName()), EElevatorAccessory::getName, bo.getName());
        lqw.eq(bo.getNumber() != null, EElevatorAccessory::getNumber, bo.getNumber());
        lqw.eq(StringUtils.isNotBlank(bo.getSpecs()), EElevatorAccessory::getSpecs, bo.getSpecs());
        lqw.eq(StringUtils.isNotBlank(bo.getDeptId()), EElevatorAccessory::getDeptId, bo.getDeptId());
        lqw.eq(StringUtils.isNotBlank(bo.getElevatorNum()), EElevatorAccessory::getElevatorNum, bo.getElevatorNum());
        lqw.orderByDesc(EElevatorAccessory::getCreateTime);
        return lqw;
    }

    /**
     * 新增电梯配件信息;
     *
     * @param bo 电梯配件信息;
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(EElevatorAccessoryBo bo) {
        EElevatorAccessory add = MapstructUtils.convert(bo, EElevatorAccessory.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改电梯配件信息;
     *
     * @param bo 电梯配件信息;
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(EElevatorAccessoryBo bo) {
        EElevatorAccessory update = MapstructUtils.convert(bo, EElevatorAccessory.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(EElevatorAccessory entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除电梯配件信息;信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
